#!/usr/local/bin/perl 
 
############################################################################
############################################################################
#
#	This Program is NOT shareware, and is NOT for resale or re-distibution
#	without express permission from the author, Matthew Redman.
#	Fairs fair, eh?
#
#	Version 2.6 - 21/10/1999 - AllManage.pl
#	Copyright 1999 Corporate Image Internet Publishing
#	http://www.prowebpages.com
#	webmaster@prowebpages.com
#
############################################################################
############################################################################
 
require 'allmanage_req.pl'; 
 
$thiscgi="all_reg.pl"; 
 
############################################################################ 
# No need to alter anything below here 
############################################################################ 
 
read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'}); 
@pairs = split(/&/,$buffer); 
 
foreach $pair (@pairs) 
	{ 
	($name,$value) = split(/=/,$pair); 
	$value =~ tr/+/ /; 
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg; 
	$FORM{$name} = $value; 
	} 
 
print "Content-type: text/html\n\n"; 
 
 
@errors = (); 
$ac_cnt = "0"; 
open(PASS,"$passfile"); 
flock(PASS, 2); 
@items = <PASS>; 
flock(PASS, 8); 
close(PASS); 
 
$onemail="0"; 
foreach (@items) 
	{ 
	$ac_cnt++; 
	chomp($_); 
	($usernm,$pword,$rel,$email,$care) = split(/\:/,$_); 
	if ($onemail == "0") 
		{ 
		if ($usernm eq "$FORM{'username'}") 
			{ 
			push(@errors,"The username you have selected is already being used. Please choose again"); 
			$onemail++; 
			} 
		if ($email eq "$FORM{'email'}") 
			{ 
			push(@errors,"Only one account is allowed per user"); 
			$onemail++; 
			} 
		} 
	} 
	 
 
$ac_cnt2 = "0"; 
 
$total_acs = ($ac_cnt + $ac_cnt2); 
 
 
open(PUT,"$basedir/pend.txt") || print "cant open the $basedir/pend.txt file: $!"; 
flock(PUT, 2); 
@pended = <PUT>; 
flock(PUT, 8); 
close(PUT); 
 
foreach (@pended) 
	{ 
	$ac_cnt2++; 
	chomp($_); 
	($usrname,$pass,$realname,$email,$rest) = split(/\:/,$_); 
	if ($onemail == "0") 
		{ 
		if ($usrname eq "$FORM{'username'}") 
			{ 
			push(@errors,"The username you have selected is already being used. Please choose again"); 
			$onemail++; 
			} 
		if ($email eq "$FORM{'email'}") 
			{ 
			push(@errors,"Only one account is allowed per user."); 
			$onemail++; 
			} 
		} 
	} 
open(ADM,"$config") || print "cant open the $config: $!"; 
flock(ADM, 2); 
@files = <ADM>; 
flock(ADM, 8); 
close(ADM); 
 
foreach $_ (@files) 
	{ 
	chomp($_); 
	($max_space,$max_ac,$style) = split(/\:/,$_); 
	if ($total_acs eq "$max_ac") 
		{ 
		open(MAX,"$basedir/max.txt") || print "cant open $basedir/max.txt because: $!"; 
		flock(MAX, 2); 
		@maxmesg = <MAX>; 
		flock(MAX, 8); 
		close(MAX); 
		 
		foreach (@maxmesg) 
			{ 
			print "$_"; 
			} 
	 
	if ($total_acs > "$max_ac") 
		{ 
		open(MAX,"$basedir/max.txt") || print "cant open $basedir/max.txt because: $!"; 
		flock(MAX, 2); 
		@maxmesg = <MAX>; 
		flock(MAX, 8); 
		close(MAX); 
		 
		foreach (@maxmesg) 
			{ 
			print "$_"; 
			} 
		} 
	exit; 
	} 
if ($FORM{'realname'} eq "") 
	{ 
	push(@errors,"You must enter a value for the real name"); 
	} 
if ($FORM{'username'} eq "") 
	{ 
	push(@errors,"You must enter a value for the username"); 
	} 
if ($FORM{'pw'} eq "") 
	{ 
	push(@errors,"You must enter a value for the password"); 
	} 
if ($FORM{'pw'} ne "$FORM{'pw2'}") 
	{ 
	push(@errors,"The passwords you entered did not match."); 
	} 
if ($FORM{'email'} !~ /(\w+)@(\w+)\.(\w+)/) 
	{ 
	push(@errors,"You must enter a valid email address"); 
	} 
if ($FORM{'email'} =~ m|([%$\/#*^&;`/])|i) 
	{ 
	push(@errors,"You entered illegal characters in your email address"); 
	} 
if ($FORM{'addy1'} eq "") 
	{ 
	push(@errors,"You must enter a value for the Address 1 field"); 
	} 
if ($FORM{'city'} eq "") 
	{ 
	push(@errors,"You must enter a value for the City"); 
	} 
if ($FORM{'state'} eq "") 
	{ 
	push(@errors,"You must enter a value for the State"); 
	} 
if ($FORM{'country'} eq "") 
	{ 
	push(@errors,"You must enter a value for the Country"); 
	} 
if ($FORM{'zip'} eq "") 
	{ 
	push(@errors,"You must enter a value for the Zip Code"); 
	} 
if ($FORM{'phone'} !~ /[0-9]/) 
	{ 
	push(@errors,"You must enter a valid phone number"); 
	} 
if ($FORM{'sex'} eq "Please Select") 
	{ 
	push(@errors,"Please select a valid sex"); 
	} 
if ($FORM{'purpose'} eq "Please Select") 
	{ 
	push(@errors,"You must select a purpose for this site"); 
	} 
	 
if (scalar(@errors) != "0") 
	{ 
	print " 
	<html> 
	<body background=\"backgrnd.gif\"> 
	<center><table border=\"0\" width=\"50\%\"> 
	<font face=\"arial,helvetica\"><b>The following errors were encountered:<b></font> 
	<p> 
	<l> 
	"; 
	foreach (@errors) 
		{ 
		print "<li><b><font color=\"red\" face=\"arial, helvetica\" size=\"\-1\">$_</font></font></font></b></li>\n"; 
		} 
	print "</l> 
</tr></td></table><p>"; 
	 
	&create_acc; 
	 
	exit; 
	} 
else	 
	{ 
	if ($style eq "Auto") 
		{ 
		$add = "$FORM{'username'}:$FORM{'pw'}:$FORM{'realname'}:$FORM{'email'}:$FORM{'addy1'}:$FORM{'addy2'}:$FORM{'city'}:$FORM{'state'}:$FORM{'country'}:$FORM{'zip'}:$FORM{'phone'}:$FORM{'sex'}:$FORM{'purpose'}:1"; 
		open(ADD,">>$passfile") || print "cant open $passfile because: $!"; 
		flock(ADD, 2); 
		print ADD "$add\n"; 
		flock(ADD, 8); 
		close(ADD); 
		$thedir = "$basedir2/$FORM{'username'}"; 
		mkdir("$thedir",777) || print "cant make dir because:$!"; 
		`chmod 777 $thedir`; 
 
		open(ADM,"$basedir/$admin_settings"); 
		flock(ADM, 2); 
		@admin = <ADM>; 
		flock(ADM, 8); 
		close(ADM);
 
		open(ADMIN2,"$basedir/header.code");
		flock(ADMIN2, 2);
		@header = <ADMIN2>;
		flock(ADMIN2, 8);
		close(ADMIN2);
 
		open(ADMIN3,"$basedir/footer.code");
		flock(ADMIN2, 3);
		@footer = <ADMIN3>;
		flock(ADMIN3, 8);
		close(ADMIN3);

		foreach (@admin) 
			{ 
			chomp($_); 
			($u,$p,$email,$t,$lu,$lr,$torb) = split(/\:/,$_); 
			} 
		open(INDEX,">$basedir2/$FORM{'username'}/index.html") || print "cant create index.html: $!"; 
		flock(INDEX, 2); 
 
		$tst = "0"; 
 
		print INDEX "<!--begin code-->\n";
		print INDEX "@header";
		print INDEX "<!--end code-->\n";

			 
		print INDEX " 
<html> 
<title>$FORM{'username'} has not finished moving in yet</title> 
<body bgcolor=\"black\"> 
<font face=\"arial, helvetica\" color=\"white\" size=\"\-1\"> 
Please check back when $FORM{'username'} has time to edit  
"; 
		if ($FORM{'sex'} eq "male") 
			{ 
			print INDEX "his site\n"; 
			} 
		elsif ($FORM{'sex'} eq "female") 
			{ 
			print INDEX "her site\n"; 
			} 
		else 
			{ 
			print INDEX "their site\n"; 
			} 
		print INDEX " 
</body> 
</html>\n"; 
		print INDEX "<!--begin code-->\n";
		print INDEX "@footer";
		print INDEX "<!--end code-->\n";

		flock(INDEX, 8); 
		close(INDEX); 
		 
		`chmod 777 "$basedir2/$FORM{'username'}/index.html`; 
		 

		open(MAIL,"|$mailprog") || print "I cant open $mailprog because: <br><B>$!</b><Br>"; 
		print MAIL "To: $email \($t\)\n";
		print MAIL "From: $FORM{'email'} \($FORM{'realname'}\)\n"; 
		print MAIL "Subject: Automatic addition to your community\n\n"; 
		print MAIL " 
		This message is to tell you $FORM{'realname'} has been 
		automatically added to the user database. 
		"; 
		close(MAIL); 
 
		open(CR,"$basedir/auto.txt");
		flock(CR, 3);
		@apprvd = <CR>;
		flock(CR, 8);
		close(CR);

		print "@apprvd"; 

 		exit; 
		} 
	else 
		{ 
		$add = "$FORM{'username'}:$FORM{'pw'}:$FORM{'realname'}:$FORM{'email'}:$FORM{'addy1'}:$FORM{'addy2'}:$FORM{'city'}:$FORM{'state'}:$FORM{'country'}:$FORM{'zip'}:$FORM{'phone'}:$FORM{'sex'}:$FORM{'purpose'}:1"; 
		open(PEND,">>$basedir/pending.file") || print "cant open $basedir/pending.file because: $!"; 
		flock(PEND, 2); 
		print PEND "$add\n"; 
		flock(PEND, 8); 
		close(PEND); 
 
		open(ADM,"$basedir/$admin_settings"); 
		flock(ADM, 2); 
		@admin = <ADM>; 
		flock(ADM, 8); 
		close(ADM); 
		 
		foreach (@admin) 
			{ 
			chomp($_); 
			($u,$p,$email,$t,$lu,$lr,$torb) = split(/\:/,$_); 
			} 
 
 
 		open(MAIL,"|$mailprog") || print "I cant open $mailprog because: <br><B>$!</b><Br>"; 
 		print MAIL "To: $email \($t\)\n";
 		print MAIL "From: $FORM{'email'} \($FORM{'realname'}\)\n"; 
 		print MAIL "Subject: Application to your community\n";
		print MAIL " 
		This message is to tell you $FORM{'realname'} has applied 
		to be added to the user database. 
		"; 
		close(MAIL); 
 
open(PEND,"$basedir/pend.txt") || print "Cant open $basedir/pend.txt because: $!"; 
@orders = <PEND>; 
close(PEND); 
 
		foreach $line (@orders) 
			{ 
			chomp($line); 
			print "$line\n"; 
			} 
		} 
	} 
exit; 
} 
 
sub create_acc 
{ 
print " 
<html>
<title>Create New Account</title>
<body bgcolor=\"white\">
<table border=\"0\" width=\"330\"> 
  <tr> 
<ts> 
    <td width=\"326\"><form method=\"POST\" action=\"$thiscgi\"> 
      <div align=\"center\"><center><table border=\"0\" cellpadding=\"3\" cellspacing=\"0\" width=\"99\%\" 
      height=\"187\"> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"text\" name=\"realname\" value=\"$FORM{'realname'}\"\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">Real Name</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"text\" name=\"username\" value=\"$FORM{'username'}\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">Username</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"19\"><input type=\"password\" name=\"pw\"></td> 
          <td width=\"50\%\" height=\"19\"><strong><font face=\"arial, helvetica\" size=\"2\">Password</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"password\" name=\"pw2\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">Confirm 
          password</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"text\" name=\"email\" value=\"$FORM{'email'}\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">Email</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"text\" name=\"addy1\" value=\"$FORM{'addy1'}\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">Address1</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"text\" name=\"addy2\" value=\"$FORM{'addy2'}\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">Address2</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"21\"><input type=\"text\" name=\"city\" value=\"$FORM{'realname'}\"></td> 
          <td width=\"50\%\" height=\"21\"><strong><font face=\"arial, helvetica\" size=\"2\">City</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"3\"><input type=\"text\" name=\"state\" value=\"$FORM{'state'}\"></td> 
          <td width=\"50\%\" height=\"3\"><strong><font face=\"arial, helvetica\" size=\"2\">State</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"3\"><input type=\"text\" name=\"country\" value=\"$FORM{'country'}\"></td> 
          <td width=\"50\%\" height=\"3\"><strong><font face=\"arial, helvetica\" size=\"2\">Country</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"3\"><input type=\"text\" name=\"zip\" value=\"$FORM{'zip'}\"></td> 
          <td width=\"50\%\" height=\"3\"><strong><font face=\"arial, helvetica\" size=\"2\">Zip</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"3\"><input type=\"text\" name=\"phone\" value=\"$FORM{'phone'}\"></td> 
          <td width=\"50\%\" height=\"3\"><strong><font face=\"arial, helvetica\" size=\"2\">Phone</font></strong></td> 
        </tr> 
        <tr> 
          <td width=\"50\%\" height=\"3\"><select name=\"sex\" size=\"1\"> 
"; 
if ($FORM{'sex'} eq "male") 
	{ 
	print " 
<option value=\"male\" selected>Male</option> 
<option value=\"female\">Female</option> 
<option value=\"Please Select\">Please Select</option> 
	"; 
	} 
elsif ($FORM{'sex'} eq "female") 
	{ 
	print " 
<option value=\"male\">Male</option> 
<option value=\"female\" selected>Female</option> 
<option value=\"Please Select\">Please Select</option> 
	"; 
	} 
else 
	{ 
	print " 
<option value=\"male\">Male</option> 
<option value=\"female\">Female</option> 
<option value=\"Please Select\" selected>Please Select</option> 
	"; 
	} 
print " 
</select></td><td><font face=\"arial, helvetica\" size=\"2\"><strong>Sex</td></tr> 
<tr><td> 
<select name=\"purpose\" size=\"1\"> 
<option value=\"Please Select\">Please Select</option> 
"; 
 
open(PURPOSE,"$basedir/purpose.list") || print "cant open $basedir/purpose.list"; 
flock(PURPOSE, 2); 
@ideas = <PURPOSE>; 
flock(PURPOSE, 8); 
close(PURPOSE); 
foreach (@ideas) 
	{ 
	chomp($_); 
	if ($_ eq "$FORM{'purpose'}") 
		{ 
		print "<option value=\"$_\" selected>$_</option>\n"; 
		} 
	else 
		{ 
		print "<option value=\"$_\">$_</option>\n"; 
		} 
	} 
print " 
         </select></td> 
          <td width=\"50\%\" height=\"3\"><font face=\"arial, helvetica\" size=\"2\"><strong>Purpose of your 
          site</strong></font></td> 
        </tr> 
      </table> 
      </center></div><div align=\"center\"><center><p>\&nbsp;<br> 
      <input type=\"submit\" name=\"whattodo\" value=\"Register\"> <input type=\"reset\" 
      value=\"Clear Form\"> </p> 
      </center></div> 
    </form> 
    </td> 
  </tr> 
</table> 
</body> 
</html> 
"; 
exit; 
}
